module DarcsDen.Google.Paths where

import Data.Maybe (fromJust)
import Network.HTTP.Conduit (parseUrl, Request)

googleApiPath :: String
googleApiPath = "https://accounts.google.com/"

googleAccessRequest, googleAccessTokenRequest :: Request m
googleAccessRequest = fromJust . parseUrl $ googleApiPath ++ "o/oauth2/auth"
googleAccessTokenRequest = fromJust . parseUrl $ googleApiPath ++ "o/oauth2/token"
